#!/bin/bash
# jphwang(2105.04.07) : supports Ubuntu14.04, Hint from "VenusDrv-1.0.4-3"
KER_VER=`uname -r`
DRIVER_PATH="/lib/modules/$KER_VER/kernel/drivers/usb/misc/"
device="nfrd08c"
major=180
minor=222
drv_file="$device.ko"
h_file="$device.h"
rule_file="99-Nitgen-$device.rules"

echo "NITGEN USB eNBioScan-C1 Driver Install "
  if [ -d $DRIVER_PATH ]; then
  # Do nothing
      echo
  else
    echo Driver Path does not exist , will create
    mkdir $DRIVER_PATH
   fi
	if [ -f $DRIVER_PATH/$drv_file  ]; then
		echo $DRIVER_PATH"nfrd08c.ko already exists"
    echo run uninstaller  to uninstall drive 
		exit 1
	fi
    if [ -f $drv_file  -a  -f $h_file  ]; then
     drvkernel=`/sbin/modinfo $drv_file | grep vermagic | cut -f8 -d " "`
     # checking for kernel version with driver compiled version .
    if [ $drvkernel == $KER_VER ]; then
        #echo "copying ----- driver DUMMY  "
		    cp -v $drv_file $DRIVER_PATH
    else
      echo your kernel version $KER_VER does not match with NITGEN USB Driver compiled kernel verion  $drvkernel
      echo you can compile NITGEN USB eNBioScan-C1 driver source
      echo and  run this script or Get $KER_VER driver binary from vendor.
      exit 1
    fi
	else
		echo "$drv_file or $h_file  file not found in current dir ....."
		exit 1;
	fi
			if [ -f /usr/include/linux/$h_file ]; then
			echo "$h_file already exists"
			exit 1
		fi
	cp -v $h_file /usr/include/linux/

#remove stale node
rm -f /dev/${device}[0-7]

# check dynamic devicefile scheme
is_dyn_usb_devfile_use=`cat /lib/modules/$KER_VER/build/include/generated/autoconf.h | grep CONFIG_USB_DYNAMIC_MINORS`
if [ -z "${is_dyn_usb_devfile_use}" ] ; then
    # static device file use...
    #create 8 nodes for the device
    mknod /dev/${device}0 c $major `expr $minor + 0`
    mknod /dev/${device}1 c $major `expr $minor + 1`
    mknod /dev/${device}2 c $major `expr $minor + 2`
    mknod /dev/${device}3 c $major `expr $minor + 3`
    mknod /dev/${device}4 c $major `expr $minor + 4`
    mknod /dev/${device}5 c $major `expr $minor + 5`
    mknod /dev/${device}6 c $major `expr $minor + 6`
    mknod /dev/${device}7 c $major `expr $minor + 7`
else
    # dynamic device file use...
    cp -av ./$rule_file /etc/udev/rules.d
fi

#move  to driver detination directory
cd $DRIVER_PATH

#install the driver module into kernel
/sbin/insmod $drv_file

# driver dependacy update
/sbin/depmod


echo "NITGEN USB eNBioScan-C1 Driver sucessfully installed."
echo "Disconnect the Device and Plug it back "
