#!/bin/bash
device="nfrd08c"
lib_file="$device.so"
conf_file="$device.conf"

# make kernel driver
./CreateModule08

# first driver install
./install-driver.sh

# second library install
if [ -f /lib/$lib_file ]; then
	echo "$lib_file already exists"
	exit 1
fi

if [ -f $lib_file ]; then
	cp -v $lib_file /lib/
else
	echo "$lib_file not exist"
	exit 1
fi

# third config file install
if [ -f $conf_file ]; then
	cp -f $conf_file /etc/
        chmod 666 /etc/$conf_file
else
	echo "$conf_file not exist"
	exit 1
fi

echo "NITGEN USB eNBioScan-C1 Library sucessfully installed "
